unit UListFrame;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics,
  Controls, Forms, Dialogs, Menus, StdCtrls, ComCtrls;

type
  TListFrame = class(TForm)
    MainMenu1: TMainMenu;
    NHidden: TMenuItem;
    NEsc: TMenuItem;
    ListView1: TListView;
    procedure NEscClick(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure ListView1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ListView1Click(Sender: TObject);
  private
    fOnValue: TNotifyEvent;
    { Private 錾 }
    procedure CreateParams(var Params: TCreateParams); override;
    procedure WMNcActivate(var msg:TWMNCActivate); message WM_NCACTIVATE;
    function GetKeyword: string;
  public
    { Public 錾 }
    fOwnerHandle:THandle;
    procedure SetItems(aStrList:TStringList);
    property Keyword:string read GetKeyword;
    property OnValue:TNotifyEvent read fOnValue write fOnValue;
  end;

var
  ListFrame: TListFrame;

implementation

{$R *.dfm}

{ TListFrame }

procedure TListFrame.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.Style := Params.Style or WS_THICKFRAME;
  Params.ExStyle := Params.ExStyle or WS_EX_CLIENTEDGE;
end;

procedure TListFrame.FormDeactivate(Sender: TObject);
begin
  Hide;
  SendMessage(fOwnerHandle, WM_SETFOCUS, 0,0);
end;

function TListFrame.GetKeyword: string;
begin
  if ListView1.ItemIndex >= 0 then
    Result := ListView1.Items[ListView1.ItemIndex].Caption else
    Result := '';
end;

procedure TListFrame.ListView1Click(Sender: TObject);
begin
  if Assigned(fOnValue) then
    fOnValue(Self);
end;

procedure TListFrame.ListView1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_RETURN then
  if Assigned(fOnValue) then
    fOnValue(Self);
end;

procedure TListFrame.NEscClick(Sender: TObject);
begin
  Hide;
end;

procedure TListFrame.SetItems(aStrList: TStringList);
var
  i:Integer;
  aItem:TListItem;
begin
  ListView1.Items.BeginUpdate;
  ListView1.Items.Clear;
  for i := 0 to aStrList.Count-1 do
  begin
    aItem := ListView1.Items.Add;
    aItem.Caption := aStrList.Strings[i];
  end;
  ListView1.Items.EndUpdate;
end;

procedure TListFrame.WMNcActivate(var msg: TWMNCActivate);
begin
  if msg.Active = False then
  begin
    inherited;
    Hide;
  end else begin
    msg.Active := False;
    inherited;
  end;
end;

end.
