unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.Menus, Vcl.ExtCtrls, Vcl.StdCtrls,
  UListFrame, Vcl.ComCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    procedure Memo1KeyPress(Sender: TObject; var Key: Char);
  private
    FDelimitter:string;
    FDelimitter_Min:Integer;
    FDelimitter_Max:Integer;
    FDelimitter_Len:Integer;

    FListFrame:TListFrame;
    FKeywordList:TStringList;
    procedure init;
    procedure GetKeywords(aText:string; aKeywordList:TStringList);
    procedure ShowListFrame(aPos:TPoint);
    procedure FListFrame_OnValue(Sender: TObject);
    procedure WMNcActivate(var msg:TWMNCActivate); message WM_NCACTIVATE;
  public
  end;

const
  delimitter = '.,[]+-/ ^\!&%#|'+#$D#$A; //؂蕶

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure SortDelimitterStr(var aText:string);
  function Compare(item1,item2:Pointer):Integer;
  begin
    Result := Integer(item1)-Integer(item2);
  end;
var
  i,len: Integer;
  aList:TList;
begin
  aList := TList.Create;
  len := Length(aText);
  aList.Count := len;
  for i := 1 to len do
    aList.List[i-1]:=Pointer(aText[i]);
  aList.Sort(@Compare);
  for i := 1 to len do
    aText[i] := Char(aList.List[i-1]);
  aList.Free;
end;

//|bvAbvꂽXgr[NbÑCxg
procedure TForm1.FListFrame_OnValue(Sender: TObject);
begin
  FListFrame.Hide;
  Memo1.SelText := FListFrame.Keyword;
end;

//eLXgL[[h擾
//f~b^ŋ܂ꂽ擾
procedure TForm1.GetKeywords(aText:string; aKeywordList:TStringList);
  function Find(cc:Integer):Boolean;
  var
    p: Integer;
  begin
    Result := True;
    if (FDelimitter_Min<=cc) and (cc<=FDelimitter_Max) then
      for p := 1 to FDelimitter_Len do
        if cc=Integer(FDelimitter[p]) then
          Exit;
    Result := False;
  end;
var
  i,aP,aLen: Integer;
begin
  aKeywordList.Clear;
  aLen := Length(aText);
  aP := 1;
  for i := 1 to aLen do
  begin
    if Find(Integer(aText[i])) then
    begin
      if i<>aP then
        aKeywordList.Add(Copy(aText, aP, i-aP));
      aP := i+1;
    end;
  end;
  if aP <= aLen then
    aKeywordList.Add(Copy(aText, aP, aLen-aP+1));
end;

procedure TForm1.init;
begin
  if FListFrame=nil then
  begin
    //
    FDelimitter := delimitter;
    SortDelimitterStr(FDelimitter);  //f~b^̃\[g(𑁂邽)
    FDelimitter_Len:=Length(FDelimitter);
    FDelimitter_Min:=Integer(FDelimitter[1]);
    FDelimitter_Max:=Integer(FDelimitter[FDelimitter_Len]);
    SortDelimitterStr(FDelimitter);
    //Xgr[ɕׂL[[hXgAd邽߃\[gĂB
    FKeywordList := TStringList.Create;
    FKeywordList.Clear;
    FKeywordList.Sorted := True;
    FKeywordList.Duplicates := dupIgnore;
    FListFrame := TListFrame.Create(Self);
    FListFrame.fOwnerHandle := Handle;
    FListFrame.OnValue := FListFrame_OnValue;
  end;
end;

procedure TForm1.Memo1KeyPress(Sender: TObject; var Key: Char);
var
  aPos:TPoint;
begin
  //Ctrl + SpaceŃXr[|bvAbv
  if (GetKeyState(VK_CONTROL) < 0) and
     (Key = Char(VK_SPACE)) then
  begin
    GetCaretPos(aPos);
    aPos.Y := aPos.Y + Abs(Memo1.Font.Height);
    aPos := Memo1.ClientToScreen(aPos);
    ShowListFrame(aPos);
    Key := #0;
  end;
end;

procedure TForm1.ShowListFrame(aPos:TPoint);
begin
  //Xgr[|bvAbv
  init;
  GetKeywords(Memo1.Text, FKeywordList);
  FListFrame.SetItems(FKeywordList);
  FListFrame.SetBounds(aPos.X,aPos.Y,FListFrame.Width,FListFrame.Height);
  FListFrame.Show;
end;

procedure TForm1.WMNcActivate(var msg: TWMNCActivate);
var
  wInfo :TWindowInfo;
begin
  //qEBhEɃtH[JXD΍
  if FListFrame<>nil then
  begin
    wInfo.cbSize :=Sizeof(TWindowInfo);
    GetWindowInfo(FListFrame.Handle, wInfo);
    if wInfo.dwStyle and WS_VISIBLE <> 0 then
      msg.Active := True;
  end;
  inherited;
end;

end.
